=== debian/changelog ===
psi (1.5+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * Acknowledge NMU.
  * Use libidn-dev instead of libidn11-dev.  Closes: #1086106.

 -- Simon Josefsson <simon@josefsson.org>  Thu, 26 Dec 2024 22:32:41 +0100

psi (1.5+dfsg1-1.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Chris Lamb ]
  * Make the build reproducible (Closes: #1017473)

 -- Vagrant Cascadian <vagrant@reproducible-builds.org>  Thu, 07 Dec 2023 13:16:09 -0800

psi (1.5+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Rewrite debian/watch from scratch.
  * Update files using wrap-and-sort tool.
  * Update debian/control:
    - set Debian XMPP Maintainers as Maintainer
    - move Jan Niehusmann to Uploaders
    - add myself to Uploaders
    - replace build dependency from debhelper (>= 9.0.0) to
      debhelper-compat (= 13)
    - bump Standards-Version to 4.5.1 (was 4.1.1): no changes required
    - add Homepage field
    - add Vcs-Git and Vcs-Browser fields
    - add "Rules-Requires-Root: no"
    - add libqt5sql5-sqlite and libsasl2-modules to Depends of package psi
    - move psi-translations from Suggests to Recommends of package psi
    - update short description of binary package psi
    - update detailed description of binary package psi
    - replace build dependency from qconf to cmake
  * Delete debian/compat.
  * Rewrite debian/rules from scratch:
    - use cmake build system
    - use all hardening flags
  * Remove extra files:
    - debian/README.Debian
    - debian/README.chinese_fonts
    - debian/dirs
    - debian/psi.xpm
    - debian/source/lintian-overrides
    - debian/source/options
    - debian/source/patch-header
  * Update debian/psi.lintian-overrides.
  * Update debian/docs.
  * Add debian/upstream/metadata.
  * Add patch 01_install-hicolor-icons.
  * Rename debian/docs to debian/psi.docs.
  * Remove trailing whitespaces in debian/changelog.
  * Rewrite debian/copyright from scratch using copyright-format/1.0.

 -- Boris Pek <tehnick@debian.org>  Wed, 03 Feb 2021 23:58:48 +0300

psi (1.3-7) unstable; urgency=medium

  * Fix FTBFS with Qt 5.15 (Closes: Bug#975122)

 -- Jan Niehusmann <jan@debian.org>  Thu, 19 Nov 2020 21:54:46 +0100
