=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

PLUGINS_SDK_DIR=$(CURDIR)/debian/psi/usr/share/psi/plugins/

CMAKEOPTS = -DBUNDLED_IRIS=ON \
            -DENABLE_PLUGINS=OFF \
            -DENABLE_WEBKIT=OFF \
            -DINSTALL_EXTRA_FILES=ON \
            -DINSTALL_PLUGINS_SDK=ON \
            -DPRODUCTION=OFF \
            -DUSE_CCACHE=ON \
            -DUSE_DBUS=ON \
            -DUSE_ENCHANT=OFF \
            -DUSE_HUNSPELL=ON \
            -DUSE_KEYCHAIN=OFF \
            -DUSE_WEBENGINE=OFF \
            -DUSE_XSS=ON \
            -DVERBOSE_PROGRAM_NAME=OFF

%:
	dh $@ --buildsystem=cmake

override_dh_dwz:
	dh_dwz || true

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKEOPTS)

override_dh_auto_install:
	dh_auto_install
	mkdir -p $(PLUGINS_SDK_DIR)
	cp -a src/plugins/include $(PLUGINS_SDK_DIR)
	cp -a src/plugins/*.pri $(PLUGINS_SDK_DIR)
